"use strict";
function writeProperties(schema) {
    return schema.properties
        .sort((a, b) => {
        // case insensitive sort
        const nameA = a.key.toUpperCase();
        const nameB = b.key.toUpperCase();
        if (nameA < nameB) {
            return -1;
        }
        if (nameA > nameB) {
            return 1;
        }
        return 0;
    })
        .map(property => {
        let result = ` ${property.key}: ${property.typescriptType};`;
        // if property is not required add the ? after the key
        if (!schema.isRequired(property.key)) {
            result = result.replace(':', '?;');
        }
        return result;
    })
        .join('\n');
}
/**
 * Created by steve.jenkins on 28/09/2016.
 */
function generateTemplate(schema) {
    return `export interface ${schema.title} {\n${writeProperties(schema)}\n}`;
}
exports.generateTemplate = generateTemplate;
